Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.apache.tapestry5.services
Interface ClasspathAssetAliasManager

All Known Implementing Classes:
  ClasspathAssetAliasManagerImpl

    @UsesMappedConfiguration(value=java.lang.String.class)
    public interface ClasspathAssetAliasManager

Used as part of the support for classpath `Asset`s, to convert the Asset's `Resource` to a URL that can be accessed by the client. The asset path, within the classpath, is converted into a shorter virtual path. The term "alias" here is generally referred to as "virtual folder" elsewhere.

Service configuration is a map from folder aliases (short names) to complete paths. Names should not start or end end with a slash. Generally, an alias should be a single name (not contain a slash). Paths should also not start or end with a slash. An example mapping would be `mylib` to `com/example/mylib`.

As originally envisioned, this service would simply optimize classpath assets, allowing the URL path for such assets to be shortened (and have a version number added, important for caching); thus the word "alias" makes sense ... it was responsible for creating an "alias" URL shorter than the default "classpath" URL.

Starting in Tapestry 5.2, this changed; all classpath assets must be "aliased" to a shorter URL path. Any URL that can not be shortened is now rejected. This simplifies creating new libraries, but also helps with security concerns, as it limits which portions of the classpath can ever be exposed to the user agent.

Tapestry automatically contributes a number of mappings: for the application root package itself (as alias "app") and for each library (via `ComponentClassResolver.getFolderToPackageMapping()`);

Method Summary
`java.util.Map<java.lang.String,java.lang.String>` | `getMappings()` Returns the mappings used by the service: the keys are the folder aliases (i.e, "corelib") and the values are the corresponding paths (i.e., "org/apache/tapestry5/corelib").
`java.lang.String` | `toClientURL(java.lang.String resourcePath)` Takes a resource path to a classpath resource and adds the asset path prefix to the path.

Method Detail

### toClientURL

    java.lang.String toClientURL(java.lang.String resourcePath)

  Takes a resource path to a classpath resource and adds the asset path prefix to the path. May also convert part of the path to an alias (based on the manager's configuration).

  Parameters:
    `resourcePath` - resource path on the classpath (with no leading slash)
  Returns:
    URL ready to send to the client

### getMappings

    java.util.Map<java.lang.String,java.lang.String> getMappings()

  Returns the mappings used by the service: the keys are the folder aliases (i.e, "corelib") and the values are the corresponding paths (i.e., "org/apache/tapestry5/corelib"). This exists primarily so that `ClasspathAssetRequestHandler`s can be created automatically for each mapping.

  Since:
    5.2.0

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2003-2012 The Apache Software Foundation.